-- 查询至少购买过顾客“张三”购买过的全部零件的顾客姓名

USE TPCH

SELECT CA.name
FROM Customer CA
WHERE NOT EXISTS(
    SELECT *
    FROM Customer CB, Orders OB, Lineitem LB
    WHERE CB.custkey = OB.custkey AND
          OB.orderkey = LB.orderkey AND
          CB.name = '张三' AND
          NOT EXISTS(
              SELECT *
              FROM Orders OC, Lineitem LC
              WHERE CA.custkey = OC.custkey AND
              OC.orderkey = LC.orderkey AND
              LB.suppkey = LC.suppkey AND
              LB.partkey = LC.partkey
          )
)
