-- 查询订单平均金额超过1w的顾客中的中国籍顾客信息

USE TPCH

SELECT C.*
FROM Customer C, (SELECT custkey
                  FROM Orders
                  GROUP BY custkey
                  HAVING AVG(totalprice) > 10000
) B, Nation N
WHERE C.custkey = B.custkey AND
      C.nationkey = N.nationkey AND N.name = '中国'
